// Copyright 2012 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

#include "runtime.h"
#include "defs_GOOS_GOARCH.h"
#include "os_GOOS.h"

uint8  runtime·goarm;	// set by 5l

// TODO: i think iOS capable of running Go should always compile
//       will GOARM=7
void
runtime·checkgoarm(void)
{
	if(runtime·goarm != 7)
		runtime·printf("runtime: you'd better recompile with GOARM=7 for better performance\n");
	return;
}

#pragma textflag 7
int64
runtime·cputicks() {
	// Currently cputicks() is used in blocking profiler and to seed runtime·fastrand1().
	// TODO(minux): stub for ios, because I don't know cheap way to get random numbers.
	return runtime·nanotime();
}

// Darwin/ARM's sigaltstack is buggy.
void
runtime·sigaltstack(struct StackT*, struct StackT*)
{
}
