// Copyright 2013 The Go Authors.  All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

#define SIG_REGS(ctxt) (((Ucontext*)(ctxt))->uc_mcontext->ss)

#define SIG_R0(info, ctxt) (SIG_REGS(ctxt).r[0])
#define SIG_R1(info, ctxt) (SIG_REGS(ctxt).r[1])
#define SIG_R2(info, ctxt) (SIG_REGS(ctxt).r[2])
#define SIG_R3(info, ctxt) (SIG_REGS(ctxt).r[3])
#define SIG_R4(info, ctxt) (SIG_REGS(ctxt).r[4])
#define SIG_R5(info, ctxt) (SIG_REGS(ctxt).r[5])
#define SIG_R6(info, ctxt) (SIG_REGS(ctxt).r[6])
#define SIG_R7(info, ctxt) (SIG_REGS(ctxt).r[7])
#define SIG_R8(info, ctxt) (SIG_REGS(ctxt).r[8])
#define SIG_R9(info, ctxt) (SIG_REGS(ctxt).r[9])
#define SIG_R10(info, ctxt) (SIG_REGS(ctxt).r[10])
#define SIG_FP(info, ctxt) (SIG_REGS(ctxt).r[11])
#define SIG_IP(info, ctxt) (SIG_REGS(ctxt).r[12])
#define SIG_SP(info, ctxt) (SIG_REGS(ctxt).sp)
#define SIG_LR(info, ctxt) (SIG_REGS(ctxt).lr)
#define SIG_PC(info, ctxt) (SIG_REGS(ctxt).pc)
#define SIG_CPSR(info, ctxt) (SIG_REGS(ctxt).cpsr)
#define SIG_FAULT_ADDRESS(info, ctxt) ((uintptr)(info)->si_addr)
#define SIG_FAULT(info, ctxt) (SIG_FAULT_ADDRESS(info, ctxt))
#define SIG_TRAP(info, ctxt) (0)
#define SIG_ERROR(info, ctxt) (0)
#define SIG_OLDMASK(info, ctxt) (0)

#define SIG_CODE0(info, ctxt) ((info)->si_code)
#define SIG_CODE1(info, ctxt) ((uintptr)(info)->si_addr)
