// Copyright 2012 The Go Authors.  All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

TEXT ·CompareAndSwapInt32(SB),7,$0
	B ·CompareAndSwapUint32(SB)

TEXT ·CompareAndSwapUint32(SB),7,$0
	B ·armCompareAndSwapUint32(SB)

TEXT ·CompareAndSwapUintptr(SB),7,$0
	B ·CompareAndSwapUint32(SB)

TEXT ·CompareAndSwapPointer(SB),7,$0
	B ·CompareAndSwapUint32(SB)

TEXT ·CompareAndSwapInt64(SB),7,$0
	B ·CompareAndSwapUint64(SB)

TEXT ·CompareAndSwapUint64(SB),7,$0
	B ·armCompareAndSwapUint64(SB)

TEXT ·AddInt32(SB),7,$0
	B	·AddUint32(SB)

TEXT ·AddUint32(SB),7,$0
	B ·armAddUint32(SB)

TEXT ·AddUintptr(SB),7,$0
	B	·AddUint32(SB)

TEXT ·AddInt64(SB),7,$0
	B	·AddUint64(SB)

TEXT ·AddUint64(SB),7,$0
	B ·armAddUint64(SB)

TEXT ·LoadInt32(SB),7,$0
	MOVW	addrptr+0(FP), R1
loadloop:
	MOVW	0(R1), R2
	MOVW	R2, R3
casl:
	LDREX	(R1), R0
	CMP		R0, R2
	BNE		loadloop
	STREX	R3, (R1), R0
	CMP		$0, R0
	BNE		casl
	MOVW	R3, val+4(FP)
	RET

TEXT ·LoadUint32(SB),7,$0
	B ·LoadInt32(SB)

TEXT ·LoadInt64(SB),7,$0
	B	·LoadUint64(SB)

TEXT ·LoadUint64(SB),7,$0
	B ·armLoadUint64(SB)

TEXT ·LoadUintptr(SB),7,$0
	B	·LoadUint32(SB)

TEXT ·LoadPointer(SB),7,$0
	B	·LoadUint32(SB)

TEXT ·StoreInt32(SB),7,$0
	B	·StoreUint32(SB)

TEXT ·StoreUint32(SB),7,$0
	MOVW	addrptr+0(FP), R1
	MOVW	val+4(FP), R3
	MOVW    R3, R2
storeloop:
	MOVW	R3, 0(R1)
casl2:
	LDREX	(R1), R0
	CMP		R0, R2
	BNE		storeloop
	STREX	R3, (R1), R0
	CMP		$0, R0
	BNE		casl2
	RET

TEXT ·StoreInt64(SB),7,$0
	B	·StoreUint64(SB)

TEXT ·StoreUint64(SB),7,$0
	B ·armStoreUint64(SB)

TEXT ·StoreUintptr(SB),7,$0
	B	·StoreUint32(SB)

TEXT ·StorePointer(SB),7,$0
	B	·StoreUint32(SB)

